unit UCanvasPixelsMethod;

{$mode delphi}

interface

uses
  Classes, SysUtils, UDrawMethod, FastBitmapCore, Graphics;

type
  { TCanvasPixelsMethod }

  TCanvasPixelsMethod = class(TDrawMethodImage)
    constructor Create; override;
    procedure DrawFrame(); override;
  end;


implementation

{ TCanvasPixelsMethod }

constructor TCanvasPixelsMethod.Create;
begin
  inherited;
  Caption := 'TBitmap.Canvas.Pixels[]';
  with Description do
  begin
    Add('Il s''agit d''une approche naïve simple pour copier l''image en accédant à la propriété Pixels.');
    Add('Cette methode est lente en raison d''une grande partie du temps d''acces dans les méthodes, ');
    Add('comme plusieurs appels de méthodes imbriqués, conversion de format de pixel, notification de mise à jour, etc.');
  end;
  Iterations := 100;
end;

procedure TCanvasPixelsMethod.DrawFrame();
var
  Y, X: Integer;
begin
    for Y := 0 to FrameHeight - 1 do
      for X := 0 to FrameWidth - 1 do
        Image.Picture.Bitmap.Canvas.Pixels[X, Y] :=RGBToColor(Random(256),Random(256),Random(256));
end;


end.

