unit UBitmapRawImageDataPaintBoxMethod;

{$mode delphi}

interface

uses
  {$IFDEF windows}Windows,{$ENDIF}Classes, SysUtils, Controls, UDrawMethod, Graphics, LCLType,
  FPimage, IntfGraphics, GraphType;

type
  { TBitmapRawImageDataPaintBoxMethod }

  TBitmapRawImageDataPaintBoxMethod = class(TDrawMethodPaintBox)
    TempBitmap: TBitmap;
    constructor Create; override;
    procedure Init(Parent: TWinControl; AWidth, AHeight:Integer);   override;
    procedure Done; override;
    procedure Paint(Sender: TObject); override;
    procedure DrawFrame(); override;
  end;


implementation

{ TBitmapRawImageDataPaintBoxMethod }

constructor TBitmapRawImageDataPaintBoxMethod.Create;
begin
  inherited;
  Caption := 'TBitmap.RawImage.Data - PaintBox';
  PaintObject := poPaintBox;
    with Description do
  begin
    Add('Remplissage complet d''un bitmap  temporaire avec des couleurs aléatoires');
    Add('à l''aide de RawImage.Data et d''un pointeur de type PCardinal et affichage dans un TPaintBox');
  end;
end;

procedure TBitmapRawImageDataPaintBoxMethod.Init(Parent: TWinControl; AWidth, AHeight:Integer);
begin
  inherited;
  TempBitmap := TBitmap.Create;
  TempBitmap.PixelFormat := pf32bit;
  TempBitmap.SetSize(AWidth, AHeight);
end;

procedure TBitmapRawImageDataPaintBoxMethod.Done;
begin
  TempBitmap.Free;
  TempBitmap:=Nil;
  inherited Done;
end;

procedure TBitmapRawImageDataPaintBoxMethod.Paint(Sender: TObject);
var
  hPaint, hBmp: HDC;
begin
  hBmp := TempBitmap.Canvas.Handle;
  hPaint := PaintBox.Canvas.Handle;
  //PaintBox.Canvas.CopyRect(Rect(0, 0, PaintBox.Width, PaintBox.Height), TempBitmap.Canvas,
  //  Rect(0, 0, TempBitmap.Width, TempBitmap.Height));
  PaintBox.Canvas.Draw(0, 0, TempBitmap);
  //BitBlt(hPaint, 0, 0, TempBitmap.Width, TempBitmap.Height, hBmp, 0, 0, srcCopy);
end;

procedure TBitmapRawImageDataPaintBoxMethod.DrawFrame();
var
  Y, X: Integer;
  PixelPtr: PCardinal;
  RowPtr: PCardinal;
  P: TPixelFormat;
  RawImage: TRawImage;
  BytePerPixel: Integer;
  BytePerRow: Integer;
begin
    try
      TempBitmap.BeginUpdate(False);
      RawImage := TempBitmap.RawImage;
      RowPtr := PCardinal(RawImage.Data);
      BytePerPixel := RawImage.Description.BitsPerPixel div 8;
      BytePerRow := RawImage.Description.BytesPerLine;
      for Y := 0 to TempBitmap.Height - 1 do begin
        PixelPtr := RowPtr;
        for X := 0 to TempBitmap.Width - 1 do begin
          PixelPtr^ := RGBToColor(Random(256),Random(256),Random(256));
          Inc(PByte(PixelPtr), BytePerPixel);
        end;
        Inc(PByte(RowPtr), BytePerRow);
      end;
    finally
      TempBitmap.EndUpdate(False);
    end;
  PaintBox.Repaint;
end;


end.

