unit UBitmapRawImageDataPixelsPtrMethod;

{$mode delphi}

interface

uses
  Classes, SysUtils, UDrawMethod, Graphics, GraphType;

type
  { TBitmapRawImageDataPointerMethod }

  TBitmapRawImageDataPointerMethod = class(TDrawMethodImage)
    constructor Create; override;
    procedure DrawFrame();  override;
  end;


implementation

{ TBitmapRawImageDataPointerMethod }

constructor TBitmapRawImageDataPointerMethod.Create;
begin
  inherited;
  Caption := 'TBitmap.RawImage.Data';
  with Description do
  begin
    Add('Remplissage complet du bitmap d''un TImage avec des couleurs aléatoires');
    Add('à l''aide de RawImage.Data et d''un pointeur de type PCardinal et affichage dans un TImage');
  end;
end;

procedure TBitmapRawImageDataPointerMethod.DrawFrame();
var
  Y, X: Integer;
  PixelPtr: PCardinal;
  RowPtr: PCardinal;
  RawImage: TRawImage;
  BytePerPixel: Integer;
  BytePerRow: Integer;
begin
    try
      Image.Picture.Bitmap.BeginUpdate(False);
      RawImage := Image.Picture.Bitmap.RawImage;
      RowPtr := PCardinal(RawImage.Data);
      BytePerPixel := RawImage.Description.BitsPerPixel div 8;
      BytePerRow := RawImage.Description.BytesPerLine;
      for Y := 0 to FrameHeight - 1 do begin
        PixelPtr := RowPtr;
        for X := 0 to FrameWidth - 1 do begin
          PixelPtr^ := RGBToColor(Random(256),Random(256),Random(256));
          Inc(PByte(PixelPtr), BytePerPixel);
        end;
        Inc(PByte(RowPtr), BytePerRow);
      end;
    finally
      Image.Picture.Bitmap.EndUpdate(False);
    end;
end;


end.

