unit UCanvasPixelsUpdateLockMethod;

{$mode delphi}

interface

uses
  Classes, SysUtils, UDrawMethod, Graphics;

type
  { TCanvasPixelsUpdateLockMethod }

  TCanvasPixelsUpdateLockMethod = class(TDrawMethodImage)
    constructor Create; override;
    procedure DrawFrame(); override;
  end;


implementation

{ TCanvasPixelsUpdateLockMethod }

constructor TCanvasPixelsUpdateLockMethod.Create;
begin
  inherited;
  Caption := 'TBitmap.Canvas.Pixels[] Update locking';
  With Description do
  begin
    Add('Cette méthode améliore l''accès aux pixels en éliminant les');
    Add('mises à jour de la zone visible pendant le traitement des pixels.');
    Add('Les données de l''image ne sont peintes qu''une seule fois à la fin de l''opération');
  end;
  Iterations := 100;
end;

procedure TCanvasPixelsUpdateLockMethod.DrawFrame();
var
  Y, X: Integer;
begin
  try
    Image.Picture.Bitmap.BeginUpdate(True);
    for Y := 0 to FrameHeight - 1 do
      for X := 0 to FrameWidth - 1 do
        Image.Picture.Bitmap.Canvas.Pixels[X, Y] := RGBToColor(Random(256),Random(256),Random(256));
  finally
    Image.Picture.Bitmap.EndUpdate(False);
  end;
end;


end.

