unit ufastBitmapHandlerPixelsMethod;

{$I beanz.inc}

interface

uses
  types, UDrawMethod, Controls, FastBitmapCore, LCLFastBitmapHandler ;
type
  { TFastBitmapHandlerPixelsMethod }

  TFastBitmapHandlerPixelsMethod = class(TDrawMethodImage)
    TestImage: TFastBitmap;
    TestLCLHandler: TLCLFastBitmapHandler;
    DestRect : TRect;
    constructor Create; override;
    destructor Destroy; override;
    procedure Init(Parent: TWinControl; AWidth, AHeight:Integer); override;
    procedure DrawFrame(); override;

  end;


implementation

{ TFastBitmapHandlerPixelsMethod }

constructor  TFastBitmapHandlerPixelsMethod.Create;
begin
  inherited;

  Caption := 'TFastBitmap.Pixel[] - LCLFastBitmapHandler';
  with Description do
  begin
    Add('Remplissage complet du bitmap avec des couleurs aléatoires');
    Add('à l''aide de TFastBitmap.Pixel[x,y]:=AColor (TCompactColor)');
    Add('Affichage dans le canvas d''un TImage avec LCLFastBitmapHandler');
  end;
  Iterations := 100;
end;

procedure TFastBitmapHandlerPixelsMethod.Init(Parent: TWinControl; AWidth, AHeight:Integer);
begin
  inherited Init(Parent, AWidth, AHeight);
  TestImage := TFastBitmap.Create(AWidth, AHeight);
  TestLCLHandler := TLCLFastBitmapHandler.Create(TestImage);
  DestRect:=Rect(0,0,AWidth-1,AHeight-1);
end;

procedure  TFastBitmapHandlerPixelsMethod.DrawFrame();
var
  Y, X: Integer;
begin
  for y:=0 to (FrameHeight-1) do
  begin
    for x:=0 to (FrameWidth-1) do
    begin
      TestImage.Pixel[X,Y]:= CompactColor(random(256),random(256),random(256),255);
    end;
  end;
  TestLCLHandler.Update;
  TestLCLHandler.DrawTo(Image.Canvas,DestRect);
end;

destructor TFastBitmapHandlerPixelsMethod.Destroy;
begin
  TestLCLHandler.Free;
  TestImage.Free;
  TestLCLHandler:=nil;
  TestImage:=nil;
  inherited Destroy;
end;


end.

