unit uFastImageColorsMethod;

{$I beanz.inc}

interface

uses
  UDrawMethod, Controls, FastBitmapCore, FPImage;
type
  { TFastImageColorsMethod }

  TFastImageColorsMethod = class(TDrawMethodFastImage)
    constructor Create; override;
    destructor Destroy; override;
    procedure Init(Parent: TWinControl; AWidth, AHeight:Integer); override;
    procedure DrawFrame(); override;

  end;


implementation

{ TFastImageColorsMethod }

constructor  TFastImageColorsMethod.Create;
begin
  inherited;

  Caption := 'TFastImage.Picture.Colors[]';
  with Description do
  begin
    Add('Affichage avec TFastImage');
    Add('Remplissage complet du bitmap avec des couleurs aléatoires');
    Add('à l''aide de FastImage.Picture.Colors[x,y]:=AColor (TFPColor)');
  end;
  Iterations:=100;
end;

procedure TFastImageColorsMethod.Init(Parent: TWinControl; AWidth, AHeight:Integer);
begin
  inherited Init(Parent, AWidth, AHeight);
  Image.Picture.SetSize(AWidth,AHeight);
end;

procedure  TFastImageColorsMethod.DrawFrame();
var
  Y, X: Integer;
begin
  for y:=0 to (FrameHeight-1) do
  begin
    for x:=0 to (FrameWidth-1) do
    begin
      // ici random $FFFF car les composants RGBA de FPColor sont codés sur 16bits
      Image.Picture.Colors[X,Y]:= FPColor(random($FFFF),random($FFFF),random($FFFF),$FFFF);
    end;
  end;
  Image.Picture.Changed();
end;

destructor TFastImageColorsMethod.Destroy;
begin
  inherited Destroy;
end;


end.

