unit uFastImagePixelMethod;

{$I beanz.inc}

interface

uses
  UDrawMethod, Controls, FastBitmapCore;
type
  { TFastImagePixelMethod }

  TFastImagePixelMethod = class(TDrawMethodFastImage)
    constructor Create; override;
    destructor Destroy; override;
    procedure Init(Parent: TWinControl; AWidth, AHeight:Integer); override;
    procedure DrawFrame(); override;

  end;


implementation

{ TFastImagePixelMethod }

constructor  TFastImagePixelMethod.Create;
begin
  inherited;

  Caption := 'TFastImage.Picture.Pixel[]';
  with Description do
  begin
    Add('Affichage avec TFastImage');
    Add('Remplissage complet du bitmap avec des couleurs aléatoires');
    Add('à l''aide de FastImage.Picture.Pixel[x,y]:=AColor (TCompactColor)');
  end;
  Iterations := 100;
end;

procedure TFastImagePixelMethod.Init(Parent: TWinControl; AWidth, AHeight:Integer);
begin
  inherited Init(Parent, AWidth, AHeight);
  Image.Picture.SetSize(AWidth,AHeight);
end;

procedure  TFastImagePixelMethod.DrawFrame();
var
  Y, X: Integer;
begin
  for y:=0 to (FrameHeight-1) do
  begin
    for x:=0 to (FrameWidth-1) do
    begin
      Image.Picture.Pixel[X,Y]:= CompactColor(random(256),random(256),random(256),255);
    end;
  end;
  Image.Picture.Changed();
end;

destructor TFastImagePixelMethod.Destroy;
begin
  inherited Destroy;
end;


end.

