unit ULazIntfImageColorsMethod;

{$mode delphi}

interface

uses
  Classes, SysUtils, UDrawMethod, IntfGraphics, GraphType,
  fpImage, Graphics;

type
  { TLazIntfImageColorsMethod }

  TLazIntfImageColorsMethod = class(TDrawMethodImage)
    TempIntfImage: TLazIntfImage;
    constructor Create; override;
    destructor Destroy; override;
    procedure DrawFrame(); override;
  end;


implementation

{ TLazIntfImageColorsMethod }

constructor TLazIntfImageColorsMethod.Create;
begin
  inherited;
  Caption := 'TLazIntfImage.Colors[]';
  TempIntfImage := TLazIntfImage.Create(0, 0);
  with Description do
  begin
    Add('Remplissage complet du bitmap avec des couleurs aléatoires');
    Add('Utilise la classe TLazIntfImage pour un accès plus rapide aux pixels du bitmap');
    Add('par rapport à un accès simple à l''aide de TBitmap.Canvas.Pixels.');
    Add('Affichage du bitmap dans un TImage à l''aide de la fonction "LoadFromIntfImage"');
  end;
end;

destructor TLazIntfImageColorsMethod.Destroy;
begin
  TempIntfImage.Free;
  TempIntfImage:=nil;
  inherited Destroy;
end;

procedure TLazIntfImageColorsMethod.DrawFrame();
var
  Y, X: Integer;
begin
    TempIntfImage.LoadFromBitmap(Image.Picture.Bitmap.Handle,Image.Picture.Bitmap.MaskHandle);
    for Y := 0 to FrameHeight - 1 do
      for X := 0 to FrameWidth - 1 do
        TempIntfImage.Colors[X, Y] := FPColor(random($FFFF),random($FFFF),random($FFFF),$FFFF);

    Image.Picture.Bitmap.LoadFromIntfImage(TempIntfImage);
end;


end.

