//------------------------------------------------------------------------------
// GLFastBitmapHandler.pas
//------------------------------------------------------------------------------
// Historique :
// 18/11/16 - BeanzMaster - Creation
//------------------------------------------------------------------------------
// Description :
// Composant graphique optimisé pour l'affichage d'un FastBitmap dans OpenGL
//
// Credits :
// Composant original :  FCL Compact Image OpenGL Interface (c) 2016, Paul F. Michell.
//------------------------------------------------------------------------------
Unit GLFastBitmapHandler;


{$i beanz.inc }

Interface

Uses
  Classes, GL, GLU,{ GLExt,} FastBitmapCore, CustomFastBitmapHandler;


Const
  GL_BGRA_EXT = $80E1;


Type
  TGLFastBitmapHandler = Class(TCustomFastBitmapHandler)
  Public
    Procedure DrawTo(DisplayRect: TRect);
  End;

Implementation

Procedure TGLFastBitmapHandler.DrawTo(DisplayRect: TRect);
//Var
//  Texture: GLUInt;
Begin
  glClearColor(0.0, 0.0, 0.0, 1.0);
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  glOrtho(0, FastBitmap.Width, 0, FastBitmap.Height, 0, 1);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity;
  glDisable(GL_DEPTH_TEST);
  glViewport(DisplayRect.Left, DisplayRect.Bottom, DisplayRect.Right, DisplayRect.Top);
  {$IFDEF BGRAIMAGE}
  glDrawPixels(FastBitmap.Width, FastBitmap.Height, GL_BGRA_EXT, GL_UNSIGNED_BYTE, FastBitmap.Data);
  {$ELSE}
  glDrawPixels(FastBitmap.Width, FastBitmap.Height, GL_RGBA, GL_UNSIGNED_BYTE, FastBitmap.Data);
  {$ENDIF}
  glRasterPos2i(0, FastBitmap.Height);
  glPixelZoom(1.0, -1.0);
End;

End.

